package com.ejie.ab79.model.inspecciones;

import java.util.Date;

import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.model.procedimientos.Procedimientos;
import com.ejie.ab79.model.protocolos.Protocolos;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * CampainasInspeccion  
 * 
 *  
 */

public class CampainasInspeccion implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idCampaina;
	private Direcciones direccion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Date fechaInicio;
	private Date fechaFin;
	private String identificadorCampaina;
	private Procedimientos procedimiento;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer numeroInspeccionados;

	// Filtrado por fechas 'desde' y 'hasta'.
	private Date fechaInicioDesde;
	private Date fechaInicioHasta;
	private Date fechaFinDesde;
	private Date fechaFinHasta;

	private Protocolos protocolo;

	private Integer countDocumentos;

	/**
	 * Method 'CampainasInspeccion'.
	 */
	public CampainasInspeccion() {
	}

	/**
	 * Method 'CampainasInspeccion'.
	 * 
	 * @param idCampaina
	 *            Integer
	 */
	public CampainasInspeccion(Integer idCampaina) {
		this.idCampaina = idCampaina;
	}

	/**
	 * Method 'CampainasInspeccion'.
	 * 
	 * @param idCampaina
	 *            Integer
	 * @param idDireccion
	 *            Integer
	 * @param descripcionCastellano
	 *            String
	 * @param descripcionEuskera
	 *            String
	 * @param fechaInicio
	 *            Date
	 * @param fechaFin
	 *            Date
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public CampainasInspeccion(Integer idCampaina, Direcciones direccion, String descripcionCastellano,
			String descripcionEuskera, Date fechaInicio, Date fechaFin, String identificadorCampaina,
			Procedimientos procedimiento, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion) {

		this.idCampaina = idCampaina;
		this.direccion = direccion;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.fechaInicio = fechaInicio;
		this.fechaFin = fechaFin;
		this.identificadorCampaina = identificadorCampaina;
		this.procedimiento = procedimiento;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdCampaina'.
	 *
	 * @return Integer
	 */

	public Integer getIdCampaina() {
		return this.idCampaina;
	}

	/**
	 * Method 'setIdCampaina'.
	 *
	 * @param idCampaina
	 *            Integer
	 * @return
	 */

	public void setIdCampaina(Integer idCampaina) {
		this.idCampaina = idCampaina;
	}

	/**
	 * Method 'getDireccion'.
	 *
	 * @return Direcciones
	 */

	public Direcciones getDireccion() {
		return this.direccion;
	}

	/**
	 * Method 'setDireccion'.
	 *
	 * @param direccion
	 *            Direcciones
	 * @return
	 */

	public void setDireccion(Direcciones direccion) {
		this.direccion = direccion;
	}

	/**
	 * Method 'getDescripcionCastellano'.
	 *
	 * @return String
	 */

	public String getDescripcionCastellano() {
		return this.descripcionCastellano;
	}

	/**
	 * Method 'setDescripcionCastellano'.
	 *
	 * @param descripcionCastellano
	 *            String
	 * @return
	 */

	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * Method 'getDescripcionEuskera'.
	 *
	 * @return String
	 */
	public String getDescripcionEuskera() {
		return this.descripcionEuskera;
	}

	/**
	 * Method 'setDescripcionEuskera'.
	 *
	 * @param descripcionEuskera
	 *            String
	 * @return
	 */
	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	/**
	 * Method 'getFechaInicio'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicio() {
		return this.fechaInicio;
	}

	/**
	 * Method 'setFechaInicio'.
	 *
	 * @param fechaInicio
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	/**
	 * Method 'getFechaFin'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFin() {
		return this.fechaFin;
	}

	/**
	 * Method 'setFechaFin'.
	 *
	 * @param fechaFin
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFin(Date fechaFin) {
		this.fechaFin = fechaFin;
	}

	/**
	 * Method 'getIdentificadorCampaina'.
	 *
	 * @return String
	 */
	public String getIdentificadorCampaina() {
		return identificadorCampaina;
	}

	/**
	 * Method 'setIdentificadorCampaina'.
	 *
	 * @param identificadorCampaina
	 *            String
	 * @return
	 */
	public void setIdentificadorCampaina(String identificadorCampaina) {
		this.identificadorCampaina = identificadorCampaina;
	}

	/**
	 * Method 'getProcedimiento'
	 * 
	 * @return Procedimientos
	 */
	public Procedimientos getProcedimiento() {
		return this.procedimiento;
	}

	/**
	 * Method 'setProcedimiento'
	 * 
	 * @param procedimiento
	 *            Procedimientos
	 * @return
	 */
	public void setProcedimiento(Procedimientos procedimiento) {
		this.procedimiento = procedimiento;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */
	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */
	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */
	public String getUsuarioUltmodificacion() {
		return usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getNumeroInspeccionados'.
	 * 
	 * @return Integer
	 */
	public Integer getNumeroInspeccionados() {
		return this.numeroInspeccionados;
	}

	/**
	 * Method 'setNumeroInspeccionados'.
	 * 
	 * @param numeroInspeccionados
	 *            Integer
	 * @return
	 */
	public void setNumeroInspeccionados(Integer numeroInspeccionados) {
		this.numeroInspeccionados = numeroInspeccionados;
	}

	/**
	 * Method 'getFechaInicioDesde'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicioDesde() {
		return fechaInicioDesde;
	}

	/**
	 * Method 'setFechaInicioDesde'.
	 *
	 * @param fechaInicioDesde
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicioDesde(Date fechaInicioDesde) {
		this.fechaInicioDesde = fechaInicioDesde;
	}

	/**
	 * Method 'getFechaInicioHasta'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaInicioHasta() {
		return fechaInicioHasta;
	}

	/**
	 * Method 'setFechaInicioHasta'.
	 *
	 * @param fechaInicioHasta
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaInicioHasta(Date fechaInicioHasta) {
		this.fechaInicioHasta = fechaInicioHasta;
	}

	/**
	 * Method 'getFechaFinDesde'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFinDesde() {
		return fechaFinDesde;
	}

	/**
	 * Method 'setFechaFinDesde'.
	 *
	 * @param fechaFinDesde
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFinDesde(Date fechaFinDesde) {
		this.fechaFinDesde = fechaFinDesde;
	}

	/**
	 * Method 'getFechaFinHasta'.
	 *
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaFinHasta() {
		return fechaFinHasta;
	}

	/**
	 * Method 'setFechaFinHasta'.
	 *
	 * @param fechaFinHasta
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaFinHasta(Date fechaFinHasta) {
		this.fechaFinHasta = fechaFinHasta;
	}

	/**
	 * @return the protocolo
	 */
	public Protocolos getProtocolo() {
		return this.protocolo;
	}

	/**
	 * @param protocolo
	 *            the protocolo to set
	 */
	public void setProtocolo(Protocolos protocolo) {
		this.protocolo = protocolo;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idCampaina: ").append(this.idCampaina).append(" ]");
		result.append(", [ direccion: ").append(this.direccion).append(" ]");
		result.append(", [ descripcionCastellano: ").append(this.descripcionCastellano).append(" ]");
		result.append(", [ descripcionEuskera: ").append(this.descripcionEuskera).append(" ]");
		result.append(", [ fechaInicio: ").append(this.fechaInicio).append(" ]");
		result.append(", [ fechaFin: ").append(this.fechaFin).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

	public Integer getCountDocumentos() {
		return countDocumentos;
	}

	public void setCountDocumentos(Integer countDocumentos) {
		this.countDocumentos = countDocumentos;
	}

}
